VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private Declare Function SHGetSpecialFolderLocation Lib "Shell32" (ByVal hwndOwner As Long, ByVal nFolder As Integer, ppidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "Shell32" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal szPath As String) As Long
Public Enum STGM
    STGM_DIRECT = &H0&
    STGM_TRANSACTED = &H10000
    STGM_SIMPLE = &H8000000
    STGM_READ = &H0&
    STGM_WRITE = &H1&
    STGM_READWRITE = &H2&
    STGM_SHARE_DENY_NONE = &H40&
    STGM_SHARE_DENY_READ = &H30&
    STGM_SHARE_DENY_WRITE = &H20&
    STGM_SHARE_EXCLUSIVE = &H10&
    STGM_PRIORITY = &H40000
    STGM_DELETEONRELEASE = &H4000000
    STGM_CREATE = &H1000&
    STGM_CONVERT = &H20000
    STGM_FAILIFTHERE = &H0&
    STGM_NOSCRATCH = &H100000
End Enum

Public Enum SHOWCMDFLAGS
    SHOWNORMAL = 5
    SHOWMAXIMIZE = 3
    SHOWMINIMIZE = 7
End Enum

Const MAX_PATH = 255

Public Type Setting
    Caption As String
    Value As String
    Name As String
End Type

Public Type lnk
    sLnkFile  As String  ' Link file name
    sExeFile  As String  ' Link - Exe file name
    sWorkDir  As String  '      - Working directory
    sExeArgs  As String  '      - Command line arguments
    sIconFile As String  '      - Icon File name
    lIconIdx  As Long    '      - Icon Index
    lShowCmd  As Long    '      - Program start state.
End Type
Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long
Private Declare Function ShellAbout Lib "shell32.dll" Alias "ShellAboutA" (ByVal hWnd As Long, ByVal szApp As String, ByVal szOtherStuff As String, ByVal hIcon As Long) As Long
Private Declare Sub SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
Const SRCCOPY = &HCC0020

Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hWnd As Long, ByVal crKey As Long, ByVal bAlpha As Long, ByVal dwFlags As Long) As Long

'   BOOL UpdateLayeredWindow(
'     HWND hwnd,             // handle to layered window
'     HDC hdcDst,            // handle to screen DC
'     POINT *pptDst,         // new screen position
'     SIZE *psize,           // new size of the layered window
'     HDC hdcSrc,            // handle to surface DC
'     POINT *pptSrc,         // layer position
'     COLORREF crKey,        // color key
'     BLENDFUNCTION *pblend, // blend function
'     DWORD dwFlags          // options
'   );
Private Declare Function UpdateLayeredWindow Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long, pptDst As POINTAPI, pSize As SIZE, ByVal hdcSrc As Long, pptSrc As POINTAPI, ByVal crKey As Long, pBlend As BLENDFUNCTION, ByVal dwFlags As Long) As Long

'   typedef struct _BLENDFUNCTION {
'     BYTE     BlendOp;
'     BYTE     BlendFlags;
'     BYTE     SourceConstantAlpha;
'     BYTE     AlphaFormat;
'   }BLENDFUNCTION, *PBLENDFUNCTION, *LPBLENDFUNCTION;
Private Type BLENDFUNCTION
   BlendOp As Byte
   BlendFlags As Byte
   SourceConstantAlpha As Byte
   AlphaFormat As Byte
End Type

Private Type POINTAPI
   x As Long
   y As Long
End Type

Private Type SIZE
   cx As Long
   cy As Long
End Type

Private Const LWA_COLORKEY = &H1&
Private Const LWA_ALPHA = &H2&
Private Const LWA_OPAQUE = &HFF&

Private Const ULW_COLORKEY = &H1
Private Const ULW_ALPHA = &H2
Private Const ULW_OPAQUE = &H4

' Style setting APIs
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Const GWL_STYLE = (-16)
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_LAYERED = &H80000

' Win32 APIs to determine OS information.
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Type OSVERSIONINFO
   dwOSVersionInfoSize As Long
   dwMajorVersion As Long
   dwMinorVersion As Long
   dwBuildNumber As Long
   dwPlatformId As Long
   szCSDVersion As String * 128
End Type
Private Const VER_PLATFORM_WIN32s = 0
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32_NT = 2


Dim os As OSVERSIONINFO

Public Function Setup(aSettings() As Setting) As Setting()

    MsgBox "This function isn't available yet", vbCritical, "Setup"

'    Dim I As Integer
    
'    Load frmSetup
'    Screen.MousePointer = vbHourglass
    
'    frmSetup.Picture = LoadPicture(oServer.GetKey("core", "background"))
'    frmSetup.picOK.Picture = LoadPicture(oServer.GetKey("core", "butfocused"))
'    frmSetup.picCancel.Picture = LoadPicture(oServer.GetKey("core", "butnormal"))

'    For I = 0 To UBound(aSettings)
'        If I > 0 Then
'            Load frmSetup.txtText(I)
'            Load frmSetup.lblText(I)
'        End If
'        frmSetup.txtText(I).Top = I * 24
'        frmSetup.txtText(I).Text = aSettings(I).Value
'        frmSetup.txtText(I).Visible = True
'
'        frmSetup.lblText(I).Top = I * 24
'        frmSetup.lblText(I).Caption = aSettings(I).Caption
'        frmSetup.lblText(I).Visible = True
'
'    Next I
'
'    frmSetup.Height = (frmSetup.txtText(UBound(aSettings)).Top + frmSetup.txtText(UBound(aSettings)).Height) * Screen.TwipsPerPixelX
'    frmSetup.Width = (frmSetup.txtText(UBound(aSettings)).Left + frmSetup.txtText(UBound(aSettings)).Width + frmSetup.lblText(UBound(aSettings)).Left) * Screen.TwipsPerPixelY
'    frmSetup.picCancel.Left = 0
'    frmSetup.picOK.Left = 0
'    frmSetup.picOK.Top = (UBound(aSettings) + 1) * frmSetup.txtText(0).Height
'    frmSetup.picCancel.Top = frmSetup.picOK.Top
'    frmSetup.picOK.Left = frmSetup.ScaleWidth - frmSetup.picOK.Width - 10
'    frmSetup.picCancel.Left = frmSetup.picOK.Left - frmSetup.picCancel.Width - 10
'    oServer.skin frmSetup
'    frmSetup.lblBar.Top = oServer.evalNum(oServer.GetKey("core", "bartop"))
'    frmSetup.lblBar.Left = oServer.evalNum(oServer.GetKey("core", "barleft"))
'    frmSetup.lblBar.Width = frmSetup.ScaleWidth - oServer.evalNum(oServer.GetKey("core", "barright")) - frmSetup.lblBar.Left
'    frmSetup.lblBar.Height = oServer.evalNum(oServer.GetKey("core", "barheight"))
'    frmSetup.lblOK.Top = frmSetup.picOK.ScaleHeight / 2 - (frmSetup.lblOK.Height / 2)
'    frmSetup.lblOK.Width = frmSetup.picOK.ScaleWidth
'    frmSetup.lblCancel.Top = frmSetup.picCancel.ScaleHeight / 2 - (frmSetup.lblCancel.Height / 2)
'    frmSetup.lblCancel.Width = frmSetup.picCancel.ScaleWidth
'    Screen.MousePointer = vbDefault
'    frmSetup.Show 1
'    While frmSetup.Visible
'        DoEvents
'    Wend
'    If frmSetup.Tag = "save" Then
'        For I = 0 To UBound(aSettings)
'            aSettings(I).Value = frmSetup.txtText(I).Text
'        Next I
'    End If
'    Setup = aSettings

End Function
Public Sub Execute(What As String)
    
    parseCommand What

End Sub
Public Sub RegisterBang(provider As String, Name As String)

    ReDim Preserve bangs(UBound(bangs) + 1)
    bangs(UBound(bangs)).Name = Name
    bangs(UBound(bangs)).provider = provider

End Sub
Public Sub SetKey(ByVal sSection As String, ByVal sKey As String, ByVal vntValue As Variant)

    oSettings.SetKey sSection, sKey, vntValue

End Sub
Public Function GetKey(ByVal sSection As String, ByVal sKey As String) As String
  
  GetKey = swapVirtual(oSettings.GetKey(sSection, sKey))
  
End Function
Public Sub DelKey(ByVal sSection As String, vntKey As String)

    oSettings.DelKey sSection, vntKey

End Sub
Public Sub DelSection(ByVal sSection As String)

    oSettings.DelSection sSection

End Sub
Public Sub CreateSection(ByVal sSection As String)

    oSettings.CreateSection sSection

End Sub
Public Function GetSections() As String()

    GetSections = oSettings.GetSections
    
End Function
Public Function evalNum(What As String) As Double

    evalNum = eval(What)
    
End Function
Public Function evalBool(What As String) As Boolean

    Dim okBool() As String
    Dim temp As String
    Dim I As Integer
    
    ReDim okBool(0)
    
    temp = oSettings.GetKey("core", "bool1")
    If temp = "" Then
        temp = "1"
    Else
        While temp <> ""
            ReDim Preserve okBool(UBound(okBool) + 1)
            okBool(UBound(okBool)) = temp
            temp = oSettings.GetKey("core", "bool" & UBound(okBool) + 1)
        Wend
    End If
    evalBool = False
    For I = 1 To UBound(okBool)
        If LCase(What) = LCase(okBool(I)) Then
            evalBool = True
        End If
    Next I

End Function
Public Function fCreateShellLink(newLnk As lnk, ShowCmd As SHOWCMDFLAGS) As Long

    Dim cShellLink   As ShellLinkA   ' An explorer IShellLinkA(Win 9x/Win NT) instance
    Dim cPersistFile As IPersistFile ' An explorer IPersistFile instance

    If (newLnk.sLnkFile = "") Or (newLnk.sExeFile = "") Then Exit Function
    On Error GoTo fCreateShellLinkError
    Set cShellLink = New ShellLinkA   'Create new IShellLink interface
    Set cPersistFile = cShellLink     'Implement cShellLink's IPersistFile interface

    With cShellLink
        'Set command line exe name & path to new ShortCut.
        .SetPath newLnk.sExeFile

        'Set working directory in shortcut
        If newLnk.sWorkDir <> "" Then .SetWorkingDirectory newLnk.sWorkDir

        'Add arguments to command line
        If newLnk.sExeArgs <> "" Then .SetArguments newLnk.sExeArgs

        'Set shortcut description
        .SetDescription "a core ShellLink " & vbNullChar
    '   If (LnkDesc <> "") Then .SetDescription pszName

        'Set shortcut icon location & index
        If newLnk.sIconFile <> "" Then .SetIconLocation newLnk.sIconFile, newLnk.lIconIdx

        'Set shortcut's startup mode (min,max,normal)
        .SetShowCmd ShowCmd
    End With

    cShellLink.Resolve 0, SLR_UPDATE
    cPersistFile.Save StrConv(newLnk.sLnkFile, vbUnicode), 0 'Unicode conversion that must be done!
    fCreateShellLink = True                           'Return Success

fCreateShellLinkError:
    Set cPersistFile = Nothing
    Set cShellLink = Nothing
End Function
Public Function fGetShellLinkInfo(sLnkFile As String) As lnk

    Dim lPidl        As Long              ' Item id list
    Dim lHotKey      As Long              ' Hotkey to shortcut...
    Dim lBuffLen     As Long
    Dim sTemp        As String
    Dim sDescription As String
    Dim cShellLink   As ShellLinkA        ' An explorer IShellLink instance
    Dim cPersistFile As IPersistFile      ' An explorer IPersistFile instance
    Dim fd           As WIN32_FIND_DATA '

    If sLnkFile = "" Then Exit Function

    Set cShellLink = New ShellLinkA       ' Create new IShellLink interface
    Set cPersistFile = cShellLink         ' Implement cShellLink's IPersistFile interface

    'Load Shortcut file...(must do this UNICODE hack!)
    On Error GoTo fGetShellLinkInfoError
    cPersistFile.Load StrConv(sLnkFile, vbUnicode), STGM_DIRECT


    With cShellLink
        'Get command line exe name & path of shortcut
        fGetShellLinkInfo.sExeFile = Space$(MAX_PATH)
        lBuffLen = Len(fGetShellLinkInfo.sExeFile)
        .GetPath fGetShellLinkInfo.sExeFile, lBuffLen, fd, SLGP_UNCPRIORITY
        sTemp = fd.cFileName  ' Not returned to calling function

        'Get working directory of shortcut
        fGetShellLinkInfo.sWorkDir = Space$(MAX_PATH)
        lBuffLen = Len(fGetShellLinkInfo.sWorkDir)
        .GetWorkingDirectory fGetShellLinkInfo.sWorkDir, lBuffLen

        'Get command line arguments of shortcut
        fGetShellLinkInfo.sExeArgs = Space$(MAX_PATH)
        lBuffLen = Len(fGetShellLinkInfo.sExeArgs)
        .GetArguments fGetShellLinkInfo.sExeArgs, lBuffLen

        'Get description of shortcut
        sDescription = Space$(MAX_PATH)
        lBuffLen = Len(sDescription)
        .GetDescription sDescription, lBuffLen ' Not returned to calling function

        'Get the HotKey for shortcut
        .GetHotkey lHotKey  ' Not returned to calling function

        'Get shortcut icon location & index
        fGetShellLinkInfo.sIconFile = Space$(MAX_PATH)
        lBuffLen = Len(fGetShellLinkInfo.sIconFile)
        .GetIconLocation fGetShellLinkInfo.sIconFile, lBuffLen, fGetShellLinkInfo.lIconIdx

        'Get Item ID List...
        .GetIDList lPidl ' Not returned to calling function

        'Set shortcut's startup mode (min,max,normal)
        .GetShowCmd fGetShellLinkInfo.lShowCmd
    End With

fGetShellLinkInfoError:
    Set cPersistFile = Nothing
    Set cShellLink = Nothing

End Function
Public Sub skin(fSkin As Object)

    Dim cTop As Long
    Dim cBottom As Long
    Dim cLeft As Long
    Dim cRight As Long
    Dim tmpControl As Control
    Dim cHeight As Long
    Dim cWidth As Long
    Dim hDC As Long
    Dim BM As BITMAP
    Dim ret As Long
    Dim hRgn As Long
    Dim tRgn As Long
    Dim y As Long
    Dim x As Long
    Dim x0 As Long
    'Dim m_Trans As CTranslucentForm
    Dim nStyle As Long

    
    cTop = oServer.evalNum(oServer.GetKey("core", "top"))
    cBottom = oServer.evalNum(oServer.GetKey("core", "bottom"))
    cRight = oServer.evalNum(oServer.GetKey("core", "right"))
    cLeft = oServer.evalNum(oServer.GetKey("core", "left"))
    fSkin.Width = fSkin.Width + (cLeft + cRight) * Screen.TwipsPerPixelX
    fSkin.Height = fSkin.Height + (cTop + cBottom) * Screen.TwipsPerPixelX
    For Each tmpControl In fSkin
        tmpControl.Top = tmpControl.Top + cTop
        tmpControl.Left = tmpControl.Left + cLeft
    Next tmpControl
    
    cHeight = fSkin.Height / Screen.TwipsPerPixelY
    cWidth = fSkin.Width / Screen.TwipsPerPixelX
    hDC = CreateCompatibleDC(0)
    If hDC Then
        SelectObject hDC, fSkin.Picture
        GetObject fSkin.Picture, Len(BM), BM
        ret = StretchBlt(fSkin.hDC, 0, 0, cWidth, cHeight, hDC, 0, 0, BM.bmWidth, BM.bmHeight, SRCCOPY)
    End If
    DeleteDC hDC
    
    If oServer.evalBool(oServer.GetKey("core", "transparant")) Then
        
        os.dwOSVersionInfoSize = Len(os)
        Call GetVersionEx(os)
        If (os.dwMajorVersion >= 5) Then
            nStyle = GetWindowLong(fSkin.hWnd, GWL_EXSTYLE) Or WS_EX_LAYERED
            If SetWindowLong(fSkin.hWnd, GWL_EXSTYLE, nStyle) Then
                Call SetLayeredWindowAttributes(fSkin.hWnd, 0, LWA_OPAQUE, LWA_ALPHA)
            End If
            Call SetLayeredWindowAttributes(fSkin.hWnd, fSkin.BackColor, 0, LWA_COLORKEY)
        Else
            hRgn = CreateRectRgn(0, 0, cWidth, cHeight)
            For y = 0 To cHeight
                For x = 0 To cWidth
                    While x <= cWidth And GetPixel(fSkin.hDC, x, y) <> fSkin.BackColor
                        x = x + 1
                    Wend
                    x0 = x
                    While x <= cWidth And GetPixel(fSkin.hDC, x, y) = fSkin.BackColor
                        x = x + 1
                    Wend
                    If x0 < x Then
                        tRgn = CreateRectRgn(x0, y, x, y + 1)
                        CombineRgn hRgn, hRgn, tRgn, 4
                        DeleteObject tRgn
                    End If
                Next x
            Next y
            Call SetWindowRgn(fSkin.hWnd, hRgn, True)
            DeleteObject hRgn
        End If
    End If
    
End Sub


