Attribute VB_Name = "modCore"
Option Explicit
Dim bExit As Boolean
Dim lSave As Long
Public m_oPlugins As core.CPluginCollection
Public oServer As core.CServer
Public oSettings As core.ISettings

Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function TransparentBlt Lib "msimg32" (ByVal hdcDest As Long, ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, ByVal nWidthDest As Long, ByVal hHeightDest As Long, ByVal hdcSrc As Long, ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, ByVal crTransparent As Long) As Boolean
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function SHShutDownDialog Lib "Shell32" Alias "#60" (ByVal YourGuess As Long) As Long
Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function LoadLibraryRegister Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibraryRegister Lib "kernel32" Alias "FreeLibrary" (ByVal hLibModule As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetProcAddressRegister Lib "kernel32" Alias "GetProcAddress" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function CreateThreadForRegister Lib "kernel32" Alias "CreateThread" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, ByVal lpparameter As Long, ByVal dwCreationFlags As Long, lpThreadID As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function GetExitCodeThread Lib "kernel32" (ByVal hThread As Long, lpExitCode As Long) As Long
Private Declare Sub ExitThread Lib "kernel32" (ByVal dwExitCode As Long)
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002

Private Const KEY_QUERY_VALUE = &H1
Private Const REG_SZ = 1

Private Const STATUS_WAIT_0 = &H0
Private Const WAIT_OBJECT_0 = ((STATUS_WAIT_0) + 0)
Private Const SW_NORMAL = 1


Public Enum REGISTER_FUNCTIONS
    DllRegisterServer = 1
    DllUnRegisterServer = 2
End Enum

Private Type Bang
    Name As String
    provider As String
End Type
Public bangs() As Bang

Public Type Info
    CompanyName As String
    FileDescription As String
    LegalCopyright As String
    ProductName As String
    FileVersion As String
    ProductVersion As String
    InternalName As String
    OriginalFilename As String
End Type
Const MAX_PATH = 255

Private Declare Function SHGetSpecialFolderLocation Lib "Shell32" (ByVal hwndOwner As Long, ByVal nFolder As Integer, ppidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "Shell32" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal szPath As String) As Long

Global Const CSIDL_DESKTOP = &H0&               ' \Desktop
Global Const CSIDL_PROGRAMS = &H2&              ' \Start Menu\Programs
Global Const CSIDL_CONTROLS = &H3&              ' No Path
Global Const CSIDL_PRINTERS = &H4&              ' No Path
Global Const CSIDL_PERSONAL = &H5&              ' \Personal
Global Const CSIDL_FAVORITES = &H6&             ' \Favorites
Global Const CSIDL_STARTUP = &H7&               ' \Start Menu\Programs\Startup
Global Const CSIDL_RECENT = &H8&                ' \Recent
Global Const CSIDL_SENDTO = &H9&                ' \SendTo
Global Const CSIDL_BITBUCKET = &HA&             ' No Path
Global Const CSIDL_STARTMENU = &HB&             ' \Start Menu
Global Const CSIDL_DESKTOPDIRECTORY = &H10&     ' \Desktop
Global Const CSIDL_DRIVES = &H11&               ' No Path
Global Const CSIDL_NETWORK = &H12&              ' No Path
Global Const CSIDL_NETHOOD = &H13&              ' \NetHood
Global Const CSIDL_FONTS = &H14&                ' \fonts
Global Const CSIDL_TEMPLATES = &H15&            ' \ShellNew
Global Const CSIDL_COMMON_STARTMENU = &H16&     ' ..\WinNT\profiles\All Users\Start Menu
Global Const CSIDL_COMMON_PROGRAMS = &H17&      ' ..\WinNT\profiles\All Users\Start Menu\Programs
Global Const CSIDL_COMMON_STARTUP = &H18&       ' ..\WinNT\profiles\All Users\Start Menu\Programs\Startup
Global Const CSIDL_COMMON_DESKTOPDIRECTORY = &H19&    '..\WinNT\profiles\All Users\Desktop
Global Const CSIDL_APPDATA = &H1A&              ' ..\WinNT\profiles\username\Application Data
Global Const CSIDL_PRINTHOOD = &H1B&            ' ..\WinNT\profiles\username\PrintHood
Sub Main()
    
    Dim ret As Long
    Dim cmdParam As String
    
    cmdParam = command
    If Len(cmdParam) > 0 Then
        If InStr(cmdParam, " ") > 0 Then
            MsgBox cmdParam
        End If
    End If
    
    If App.PrevInstance Then End
    bExit = False
    ReDim bangs(0)
    Set m_oPlugins = New core.CPluginCollection
    Set oServer = New core.CServer
    
    ret = loadSections
    If ret = 0 Then
        While Not bExit
            Call Sleep(100)
            DoEvents
        Wend
        Call UnloadPlugins
    Else
        Select Case ret
        Case -1
            MsgBox "Couldn't register the settings module which is required to run core, File Could Not Be Loaded Into Memory Space", vbCritical, "Error on registering the settings module"
        Case -2
            MsgBox "Couldn't register the settings module which is required to run core, Not A Valid ActiveX Component", vbCritical, "Error on registering the settings module"
        Case -3
            MsgBox "Couldn't register the settings module which is required to run core, ActiveX Component Registration Failed", vbCritical, "Error on registering the settings module"
        Case -4
            MsgBox "No modules found to load, running core without modules is of no use.", vbCritical, "No modules found"
        Case Else
            MsgBox "Couldn't load the settings module which is required to run core. Does the file settings.dll exist in your core directory? (errorcode " & ret & ")", vbCritical, "No settings module found"
        End Select
    End If
    End

End Sub
Public Function RegisterComponent(ByVal FileName As String, ByVal RegFunction As REGISTER_FUNCTIONS) As Long

    Dim lngLib As Long
    Dim lngProcAddress As Long
    Dim lpThreadID As Long
    Dim fSuccess As Long
    Dim dwExitCode As Long
    Dim hThread As Long
    
    If FileName = "" Then Exit Function
    
    lngLib = LoadLibraryRegister(FileName)
    If lngLib = 0 Then
        RegisterComponent = -1
        Exit Function
    End If
    
    Select Case RegFunction
    Case REGISTER_FUNCTIONS.DllRegisterServer
        lngProcAddress = GetProcAddressRegister(lngLib, "DllRegisterServer")
    Case REGISTER_FUNCTIONS.DllUnRegisterServer
        lngProcAddress = GetProcAddressRegister(lngLib, "DllUnregisterServer")
    Case Else
    End Select
    
    If lngProcAddress = 0 Then
       RegisterComponent = -2
       If lngLib Then Call FreeLibraryRegister(lngLib)
       Exit Function
    Else
       hThread = CreateThreadForRegister(ByVal 0, 0, ByVal lngProcAddress, ByVal 0, 0, lpThreadID)
       If hThread Then
            fSuccess = (WaitForSingleObject(hThread, 10000) = WAIT_OBJECT_0)
            If Not fSuccess Then
               Call GetExitCodeThread(hThread, dwExitCode)
               Call ExitThread(dwExitCode)
               RegisterComponent = -3
               If lngLib Then Call FreeLibraryRegister(lngLib)
               Exit Function
            Else
                If RegFunction = DllRegisterServer Then
                    RegisterComponent = 0
                ElseIf RegFunction = DllUnRegisterServer Then
                    RegisterComponent = 0
                End If
            End If
            Call CloseHandle(hThread)
            If lngLib Then Call FreeLibraryRegister(lngLib)
       End If
    End If

End Function
Public Sub LoadPlugin(Name As String, Plugin As String)

    Dim ret As Long
    Dim sClassID As String
    Dim oPlugin As core.IBasePlugin

    oServer.Execute "!log Loading module " & Plugin & " as " & Name
    On Error GoTo error_cmdLoad_Click
    
    If (m_oPlugins Is Nothing) Then
        Set m_oPlugins = New core.CPluginCollection
    End If

    sClassID = noPath(Plugin)
    If InStr(sClassID, ".") Then
        sClassID = Left(sClassID, InStr(sClassID, ".") - 1)
    End If
    sClassID = sClassID & ".CPlugin"

    Set oPlugin = m_oPlugins(Name)

retry_plugin:
    If (oPlugin Is Nothing) Then
        Set oPlugin = CreateObject(sClassID)
        Call oPlugin.StartPlugin(Name)
        Call m_oPlugins.Add(oPlugin, Name)
    End If
    Set oPlugin = Nothing

exit_cmdLoad_Click:
    Exit Sub

error_cmdLoad_Click:
    If Err.Number = 429 Then
        oServer.Execute "!log Registering " & Plugin
        ret = RegisterComponent(Trim(Plugin), DllRegisterServer)
        If ret = 0 Then
            Resume retry_plugin
        Else
            Select Case ret
            Case -1
                oServer.Execute "!log Error while loading plugin, File Could Not Be Loaded Into Memory Space"
            Case -2
                oServer.Execute "!log Error while loading plugin, Not A Valid ActiveX Component"
            Case -3
                oServer.Execute "!log Error while loading plugin, ActiveX Component Registration Failed"
            End Select
        End If
    Else
        oServer.Execute "!log " & Err.Number & ", " & Err.Description
        Resume exit_cmdLoad_Click
    End If

End Sub
Public Sub UnloadPlugin(Name As String)

    Dim oPlugin As core.IBasePlugin
    
    Set oPlugin = m_oPlugins(Name)
    If Not oPlugin Is Nothing Then
        Call oPlugin.StopPlugin
        m_oPlugins.Remove Name
        oServer.Execute "!log Unloaded " & Name
    Else
        oServer.Execute "!log There is no module loaded with the name " & Name
    End If

End Sub
Public Sub UnloadPlugins()
    
    If (Not (m_oPlugins Is Nothing)) Then
        Dim oPlugin As core.IBasePlugin
    
        For Each oPlugin In m_oPlugins
            Call oPlugin.StopPlugin
        Next
    
        Set m_oPlugins = Nothing
    End If

End Sub
Public Sub parseCommand(textline As String)

    Dim I As Long
    Dim command As String
    Dim parameter As String
    Dim oPlugin As core.IBasePlugin
    Dim found As Boolean
    
    If InStr(textline, " ") Then
        command = Left(textline, InStr(textline, " ") - 1)
        parameter = Right(textline, Len(textline) - InStr(textline, " "))
    Else
        parameter = ""
        command = textline
    End If
    Select Case LCase(command)
    Case "!shutdown"
        SHShutDownDialog 0
        bExit = True
    Case "!unload"
        UnloadPlugin parameter
    Case "!load"
        If InStr(parameter, " ") > 0 Then
            command = Left(parameter, InStr(parameter, " ") - 1)
            parameter = Right(parameter, Len(parameter) - InStr(parameter, " "))
            LoadPlugin parameter, command
        Else
            command = InputBox("Please name this instance", "Load plugin", "")
            If command <> "" Then
                LoadPlugin command, parameter
            End If
        End If
    Case "!about"
        frmAbout.Show
    Case "!quit"
        bExit = True
    Case Else
        If Left(command, 1) = "!" Then
            found = False
            For I = 0 To UBound(bangs)
                If LCase(command) = LCase(bangs(I).Name) Then
                    found = True
                    Set oPlugin = m_oPlugins(bangs(I).provider)
                    oPlugin.Bang LCase(command), parameter
                End If
            Next I
            If LCase(command) = "!log" And Not found And Not oServer.evalBool(oServer.GetKey("core", "nomsg")) Then
                
                MsgBox parameter
            End If
        Else
            RunFile noPath(textline), path(textline), SW_NORMAL
        End If
    End Select

End Sub
Public Function hWndShell(ByVal JobToDo As String, Optional ExecMode) As Long
   
   Dim ProcessID As Long
   Dim PID As Long
   Dim hProcess As Long
   Dim hWndJob As Long

   If IsMissing(ExecMode) Then
      ExecMode = vbMinimizedNoFocus
   Else
      If ExecMode < vbHide Or ExecMode > vbMinimizedNoFocus Then
         ExecMode = vbMinimizedNoFocus
      End If
   End If

   On Error GoTo error
      ProcessID = Shell(JobToDo, CLng(ExecMode))
      If Err Then
         hWndShell = 0
         Exit Function
      End If

error:
   On Error GoTo 0

End Function
Public Sub RunFile(ByVal File As String, FilePath As String, RunStyle As Long)
    
    Const MB_ICONSTOP = 16
    Dim temp As String
    Dim Msg As String
    Dim X As Long
    temp = GetActiveWindow()
    X = ShellExecute(temp, "Open", File, "", FilePath, RunStyle)

    If X < 32 Then

        Select Case X
            Case 0
            Msg = "The file could Not be run due To insufficient system memory or a corrupt program file"
            Case 2
            Msg = "File Not Found"
            Case 3
            Msg = "Invalid Path"
            Case 5
            Msg = "Sharing or protection error"
            Case 6
            Msg = "Separate data segments are required For Each task "
            Case 8
            Msg = "Insufficient memory To run the program"
            Case 10
            Msg = "Incorrect Windows version"
            Case 11
            Msg = "Invalid Program File"
            Case 12
            Msg = "Program file requires a different operating System "
            Case 13
            Msg = "Program requires MS-DOS 4.0"
            Case 14
            Msg = "Unknown program file type"
            Case 15
            Msg = "Windows prgram does Not support protected memory mode"
            Case 16
            Msg = "Invalid use of data segments when loading a second instance of a program"
            Case 19
            Msg = "Attempt To run a compressed program file"
            Case 20
            Msg = "Invalid dynamic link library"
            Case 21
            Msg = "Program requires Windows 32-bit extensions"
            Case 31
            Msg = "No application found For this file"
        End Select
    End If

End Sub
Private Function noPath(ByVal wPath As String) As String

    While InStr(wPath, "\")
        wPath = Right(wPath, Len(wPath) - InStr(wPath, "\"))
    Wend
    noPath = wPath

End Function
Private Function path(ByVal wPath As String) As String

    path = Left(wPath, Len(wPath) - Len(noPath(wPath)))

End Function
Function loadSections() As Long

    Dim textline As String
    Dim I As Integer
    Dim ret As Long
    Dim sections() As String
    ReDim sections(0)
    
    On Error GoTo reg_settings
load_settings:
    Set oSettings = CreateObject("settings.CSettings")
    On Error GoTo 0
    
    sections = oSettings.GetSections
    For I = 1 To UBound(sections)
        If LCase(sections(I)) <> "core" Then
            textline = oSettings.GetKey(sections(I), "module")
            If textline <> "" Then
                LoadPlugin sections(I), textline
            'Else
            '    oServer.Execute "!log Error loading " & sections(I) & ", no module specified"
            End If
        End If
    Next I
    If UBound(sections) > 0 Then
        loadSections = 0
    Else
        loadSections = -4
    End If
    Exit Function
    
reg_settings:

    If Err.Number = 429 Then
        ret = RegisterComponent(App.path & "\settings.dll", DllRegisterServer)
        If ret = 0 Then
            Resume load_settings
        Else
            loadSections = ret
        End If
    Else
        loadSections = Err.Number
    End If

End Function
Public Function swapVirtual(What As String) As String

    Dim textline As String
    Dim Name As String
    Dim StopIt As Boolean
    Dim hCurKey As Long
    Dim lngDataBufferSize As Long
    Dim lngValueType As Long
    Dim strBuffer As String
    Dim sPath As String
    Dim hwnd As Long

    hwnd = GetDesktopWindow()

    
    StopIt = False
    textline = What
    While InStr(textline, "$") And Not StopIt
        Name = Right(textline, Len(textline) - InStr(textline, "$"))
        If InStr(Name, "$") Then
            Name = Left(Name, InStr(Name, "$") - 1)
            Select Case LCase(Name)
            Case "programs"
                If fGetSystemFolderPath(hwnd, CSIDL_PROGRAMS, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "personal"
                If fGetSystemFolderPath(hwnd, CSIDL_PERSONAL, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "favorites"
                If fGetSystemFolderPath(hwnd, CSIDL_FAVORITES, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "startup"
                If fGetSystemFolderPath(hwnd, CSIDL_STARTUP, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "recent"
                If fGetSystemFolderPath(hwnd, CSIDL_RECENT, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "sendto"
                If fGetSystemFolderPath(hwnd, CSIDL_SENDTO, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "nethood"
                If fGetSystemFolderPath(hwnd, CSIDL_NETHOOD, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "fonts"
                If fGetSystemFolderPath(hwnd, CSIDL_FONTS, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "templates"
                If fGetSystemFolderPath(hwnd, CSIDL_TEMPLATES, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "common_startmenu"
                If fGetSystemFolderPath(hwnd, CSIDL_COMMON_STARTMENU, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "common_programs"
                If fGetSystemFolderPath(hwnd, CSIDL_COMMON_PROGRAMS, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "common_startup"
                If fGetSystemFolderPath(hwnd, CSIDL_COMMON_STARTUP, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "common_desktopdirectory"
                If fGetSystemFolderPath(hwnd, CSIDL_COMMON_DESKTOPDIRECTORY, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "desktopdirectory"
                If fGetSystemFolderPath(hwnd, CSIDL_DESKTOPDIRECTORY, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "appdata"
                If fGetSystemFolderPath(hwnd, CSIDL_APPDATA, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "printhood"
                If fGetSystemFolderPath(hwnd, CSIDL_PRINTHOOD, sPath) Then
                    textline = Replace(textline, "$" & Name & "$", sPath)
                End If
            Case "screenheight"
                textline = Replace(textline, "$" & Name & "$", Screen.Height / Screen.TwipsPerPixelY)
            Case "screenwidth"
                textline = Replace(textline, "$" & Name & "$", Screen.Width / Screen.TwipsPerPixelX)
            Case Else
                textline = Replace(textline, "$" & Name & "$", oSettings.GetKey("core", Name))
            End Select
        Else
            StopIt = True
        End If
    Wend
    swapVirtual = textline

End Function
Public Function fGetSystemFolderPath(ByVal hwnd As Long, ByVal Id As Integer, sfPath As String) As Long

    Dim lReturn As Long
    Dim lPidl   As Long
    Dim lPath   As Long
    Dim sPath   As String

    sPath = Space$(MAX_PATH)
    lReturn = SHGetSpecialFolderLocation(hwnd, Id, lPidl)  ' Get lPidl for Id...
    If lReturn = 0 Then                                    ' If success is 0
        lReturn = SHGetPathFromIDList(lPidl, sPath)        '   Get Path from Item Id List
        If lReturn = 1 Then                                '   If success is 1
            sPath = Trim$(sPath)                           '     Fix path string
            lPath = Len(sPath)                             '     Get length of path
            If Asc(Right$(sPath, 1)) = 0 Then lPath = lPath - 1 'Adjust path length
            If lPath > 0 Then sfPath = Left$(sPath, lPath) '     Adjust path string variable
            fGetSystemFolderPath = True                    '     Return success
        End If
    End If

End Function
